/*  trim filter -- reads file of strings from stdin and removes dupes  
		 
    Copyright (C) 1985,1987,1991,1994,1996,2003  Norm London, London Computing

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	norm_london@londoncomputing.com

	Windows:     Compile with Visual Studio 5 or later or gcc 2.9.5 or later
	should work with just about any c compiler.
	cl trim.c
	windows or unix using gcc:
	gcc unique.c -o unique.exe
*/
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
char s[4096];

char *ltrim(char *s) {
	while(*s && isspace(*s))
		++s;
	return s;
}

char *trim(char *s)
{
 char *c;
	for(c=s+strlen(s)-1;c >= s && isspace(*c);--c);
	*(++c) = '\n';		//Using fputs to write, attend linefeed
	*(++c) = 0;
	return s;
}


int main(int argc,char *argv[])
{
 /*routine to remove trailing blanks from a file.  syntax: trim in out  */
	int rflag=0,lflag=0;

	if (argc < 2) {
		fputs("trim--remove leading/trailing white space\n",stderr);
		fprintf(stderr,"trim Filter V1.01 %s \n",__DATE__);
		fprintf(stderr,"Copyright 1985-2003, Norm London, London Computing.\nnorm_london@londoncomputing.com\n\n");
		fprintf(stderr,"This program is free software; you can redistribute it and/or modify\n");
		fprintf(stderr,"it under the terms of the GNU General Public License as published by\n");
		fprintf(stderr,"the Free Software Foundation; either version 2 of the License, or\n");
		fprintf(stderr,"(at your option) any later version.\n\n");
		fprintf(stderr,"This program is distributed in the hope that it will be useful,\n");
		fprintf(stderr,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
		fprintf(stderr,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
		fprintf(stderr,"GNU General Public License for more details.\n\n");
		fprintf(stderr,"You should have received a copy of the GNU General Public License\n");
		fprintf(stderr,"along with this program; if not, write to the Free Software\n");
		fprintf(stderr,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
		fputs("Usage is: trim {-r|-l|-rl} [<infile.ext] [>outfile.ext]\n",stderr);
		fputs("-r -- trim from right\n",stderr);
		fputs("-l -- trim from left \n",stderr);
		fputs("-rl-- trim from right and left\n",stderr);
		return(1);
	}


	if (toupper(argv[1][1]) == 'R')
		rflag = 1;
	
	if (toupper(argv[1][1]) == 'L')
		lflag = 1;


	if (toupper(argv[1][2]) == 'R')
		rflag = 1;
	
	if (toupper(argv[1][2]) == 'L')
		lflag = 1;



	while (fgets(s,sizeof(s),stdin) != NULL)
		if (rflag && lflag)
			fputs(ltrim(trim(s)),stdout);
		else if (rflag)
			fputs(trim(s),stdout);
		else if (lflag)
			fputs(ltrim(s),stdout);
		else
			fputs(s,stdout);

	return(0);
}
